// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI64C200K/24DSI64C200K_linux_1.x_gsc_dn/samples/billion/perform.c $
// $Rev: 52117 $
// $Date: 2022-12-01 11:43:41 -0600 (Thu, 01 Dec 2022) $

// 24DSI64C200K: Sample Application: source file

#include "main.h"



// macros *********************************************************************

#define	_1B		(1000L * 1000L * 1000L)
#define	_1M		(1000L * 1000L)



// variables ******************************************************************

static	u32	_buffer[_1M];



//*****************************************************************************
static int _read_data(const args_t* args)
{
	char	buf[64];
	int		qty		= 0;
	int		errs	= 0;
	long	get;
	long	got;
	long	total	= 0;

	gsc_label("Reading");
	printf("\n");

	gsc_label_level_inc();
	printf("  Index  Running Total\n");
	printf("  =====  =============\n");

	for (;;)
	{
		qty++;
		get	= sizeof(_buffer);
		got	= dsi64c200k_read(args->fd, _buffer, get);

		if (got < 0)
		{
			errs	= 1;
			printf(	"FAIL <---  (read error, errno %d)\n", errno);
			break;
		}

		total	+= got / 4;

		if (got == 0)
		{
			errs	= 1;
			printf(	"FAIL <---  (total %ld, requested %ld samples, got %ld samples)\n",
					(long) total,
					(long) get,
					(long) got);
			break;
		}

		if (((qty % 10) == 0) || (total >= _1B))
		{
			gsc_label_long_comma_buf(total, buf);
			printf("  %5d  %13s\n", qty, buf);
		}

		if (total >= _1B)
			break;
	}

	gsc_label_level_dec();
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	errs	+= dsi64c200k_config_ai			(args->fd, -1, 1, -1, 25000);
	errs	+= dsi64c200k_rx_io_mode		(args->fd, -1, 1, args->io_mode, NULL);
	errs	+= dsi64c200k_rx_io_overflow	(args->fd, -1, 1, DSI64C200K_IO_OVERFLOW_IGNORE, NULL);
	errs	+= dsi64c200k_rx_io_underflow	(args->fd, -1, 1, DSI64C200K_IO_UNDERFLOW_IGNORE, NULL);
	errs	+= _read_data(args);

	return(errs);
}



