// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI64C200K/24DSI64C200K_linux_1.x_gsc_dn/samples/fsamp/perform.c $
// $Rev: 52120 $
// $Date: 2022-12-01 11:44:32 -0600 (Thu, 01 Dec 2022) $

// 24DSI64C200K: Sample Application: source file

#include "main.h"



// macros *********************************************************************

#define	FILE_NAME				"fsamp.txt"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int		errs	= 0;
	FILE*	file	= NULL;
	s32		fref;
	s32		fsamp;
	s32		max		= 0;
	s32		min		= 0;
	s32		nref;
	s32		nvco;
	double	rate;

	gsc_label("Fsamp Computation");
	printf("\n");
	gsc_label_level_inc();

	if (args->range == 0)
	{
		min		= args->fsamp;
		max		= args->fsamp;
		errs	+= dsi64c200k_query(args->fd, -1, 0, DSI64C200K_QUERY_FREF_DEFAULT, &fref);
	}
	else
	{
		errs	+= dsi64c200k_query(args->fd, -1, 0, DSI64C200K_QUERY_FSAMP_MAX, &max);
		errs	+= dsi64c200k_query(args->fd, -1, 0, DSI64C200K_QUERY_FSAMP_MIN, &min);
		errs	+= dsi64c200k_query(args->fd, -1, 0, DSI64C200K_QUERY_FREF_DEFAULT, &fref);
	}

	if (args->save)
	{
		file	= fopen(FILE_NAME, "w+b");

		if (file == NULL)
		{
			printf("FAIL <---  (unable to create %s)\n", FILE_NAME);
			errs	= 1;
		}
		else
		{
			fprintf(file, "# 24DSI64C200K Scan Rates\n");
			fprintf(file, "# Request   Produced\n");
			fprintf(file, "# ========  =============\n");
		}
	}

	for (fsamp = min; fsamp <= max; fsamp++)
	{
		s32	fg	= args->fgen_div;
		s32	mc	= args->mclk_div;
		s32	ov	= args->over_sample;

		errs	+= dsi64c200k_fsamp_ai_compute(args->fd, -1, 1, fref, fsamp, args->optimal, &nvco, &nref, &fg, &mc, &ov, &rate);

		if (file)
			fprintf(file, "%10ld  %13.6f\n", (long) fsamp, (double) rate);
	}

	if (file)
		fclose(file);

	gsc_label_level_dec();
	return(errs);
}


