// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI64C200K/24DSI64C200K_linux_1.x_gsc_dn/samples/id/perform.c $
// $Rev: 52121 $
// $Date: 2022-12-01 11:44:47 -0600 (Thu, 01 Dec 2022) $

// 24DSI64C200K: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _clocking(void)
{
	gsc_label("Clocking Sources");
	printf("Internal, External, Software, Burst\n");
	return(0);
}



//*****************************************************************************
static int _clocking_transceivers(void)
{
	gsc_label("Clocking Transceivers");
	printf("TTL, LVDS\n");
	return(0);
}



//*****************************************************************************
static int _dio_pins(void)
{
	gsc_label("GPIO Pins");
	printf("4, independently configurable\n");
	return(0);
}



//*****************************************************************************
static int _fgen_divisors(void)
{
	gsc_label("Fgen Divisors");
	printf("1, 2, 4, 8, 16\n");
	return(0);
}



//*****************************************************************************
static int _input_modes(void)
{
	gsc_label("Input Modes");
	printf("Differential, Zero Test, +Vref Test\n");
	return(0);
}



//*****************************************************************************
static int _mclk_divisors(void)
{
	gsc_label("Mclk Divisors");
	printf("32 (Eco), 8 (Median), 4 (Fast)\n");
	return(0);
}



//*****************************************************************************
static int _over_sample_factors(void)
{
	gsc_label("Over Sample Factors");
	printf("32, 64, 128, 1024\n");
	return(0);
}



//*****************************************************************************
static int _resolutions(void)
{
	gsc_label("Resolutions");
	printf("24-bit, 20-bit, 18-bit, 16-bit\n");
	return(0);
}



//*****************************************************************************
static int _id_device_bcfgr(const args_t* args)
{
	gsc_reg_def_t			list[2]	= { { NULL }, { NULL } };
	const gsc_reg_def_t*	ptr;

	int	errs	= 0;

	printf("\n");
	ptr	= dsi64c200k_reg_get_def_id(DSI64C200K_GSC_BCFGR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, dsi64c200k_reg_read);
	}
	else
	{
		errs++;
		printf(	"FAIL <---  (%d. dsi64c200k_reg_get_def_id, DSI64C200K_GSC_BCFGR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= dsi64c200k_reg_list(args->fd, args->detail);
	printf("\n");
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	errs	+= _clocking();
	errs	+= _clocking_transceivers();
	errs	+= _dio_pins();
	errs	+= _fgen_divisors();
	errs	+= _input_modes();
	errs	+= _mclk_divisors();
	errs	+= _over_sample_factors();
	errs	+= _resolutions();

	for (i = 0; i < DSI64C200K_QUERY_LAST; i++)
		errs	+= dsi64c200k_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_bcfgr(args);
	errs	+= _register_map(args);
	printf("\n");

	return(errs);
}


