// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI64C200K/24DSI64C200K_linux_1.x_gsc_dn/samples/irq/main_dma.c $
// $Rev: 43018 $
// $Date: 2018-06-22 17:33:51 -0500 (Fri, 22 Jun 2018) $

// 24DSI64C200K: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _irq_check_support(void)
{
	return(STATUS_SUPPORTED);
}



//*****************************************************************************
static int _irq_initiate(int fd)
{
	char	buf[200];
	int		errs		= 0;
	int		got;

	errs	+= dsi64c200k_config_ai		(fd, -1, 0, -1, 250000);
	errs	+= dsi64c200k_rx_io_mode	(fd, -1, 0, GSC_IO_MODE_DMDMA, NULL);
	errs	+= dsi64c200k_rx_io_overflow(fd, -1, 0, DSI64C200K_IO_OVERFLOW_IGNORE, NULL);

	os_sleep_ms(50);

	got	= dsi64c200k_read(fd, buf, sizeof(buf));

	if (got < 0)
	{
		errs++;
		printf("ERROR: dsi64c200k_read() failure\n");
	}

	return(errs);
}



//*****************************************************************************
int main_dma_irq_test(int fd, int supported)
{
	int	ret;

	if (supported)
		ret	= _irq_check_support();
	else
		ret	= _irq_initiate(fd);

	return(ret);
}


